From 8c1e68fa53b070a00e39672473692e1096a94977 Mon Sep 17 00:00:00 2001
From: David Malcolm <dmalcolm@redhat.com>
Date: Thu, 17 Jul 2025 11:15:14 -0400
Subject: [PATCH 28/41] {needs ChangeLog} move diagnostic_context to
 diagnostics::context in its own header (and related classes)

---
 gcc/ada/gcc-interface/misc.cc                 |    2 +-
 gcc/analyzer/program-point.cc                 |    6 +-
 gcc/c-family/c-common.h                       |    2 +-
 gcc/c-family/c-opts.cc                        |    4 +-
 gcc/c/c-objc-common.cc                        |    2 +-
 gcc/c/c-tree.h                                |    2 +-
 gcc/coretypes.h                               |    6 +-
 gcc/cp/cp-tree.h                              |    2 +-
 gcc/cp/error.cc                               |   10 +-
 gcc/cp/module.cc                              |    8 +-
 gcc/diagnostic-global-context.cc              |    8 +-
 gcc/diagnostic.cc                             |  191 ++--
 gcc/diagnostic.h                              | 1001 +----------------
 gcc/diagnostics/buffering.h                   |   16 +-
 gcc/diagnostics/client-data-hooks.h           |    6 +-
 gcc/diagnostics/context.h                     |  988 ++++++++++++++++
 gcc/diagnostics/html-sink.cc                  |   46 +-
 gcc/diagnostics/html-sink.h                   |   12 +-
 gcc/diagnostics/lazy-paths.cc                 |    4 +-
 gcc/diagnostics/output-file.h                 |    2 +-
 gcc/diagnostics/output-spec.cc                |   22 +-
 gcc/diagnostics/output-spec.h                 |    6 +-
 gcc/diagnostics/paths-output.cc               |   24 +-
 gcc/diagnostics/sarif-sink.cc                 |   98 +-
 gcc/diagnostics/sarif-sink.h                  |   18 +-
 gcc/diagnostics/sink.h                        |   16 +-
 gcc/diagnostics/source-printing.cc            |  224 ++--
 gcc/diagnostics/text-sink.cc                  |   33 +-
 gcc/diagnostics/text-sink.h                   |   26 +-
 gcc/fortran/error.cc                          |   26 +-
 gcc/gcc-rich-location.h                       |    6 +-
 gcc/gcc.cc                                    |    2 +-
 gcc/gdbinit.in                                |    6 +-
 gcc/jit/dummy-frontend.cc                     |    6 +-
 gcc/jit/jit-playback.h                        |    7 +-
 gcc/langhooks-def.h                           |    2 +-
 gcc/langhooks.cc                              |    4 +-
 gcc/langhooks.h                               |    2 +-
 gcc/libgdiagnostics.cc                        |   12 +-
 gcc/optc-gen.awk                              |    4 +-
 gcc/opth-gen.awk                              |    4 +-
 gcc/opts-common.cc                            |   10 +-
 gcc/opts-diagnostic.cc                        |    6 +-
 gcc/opts-diagnostic.h                         |   12 +-
 gcc/opts-global.cc                            |    6 +-
 gcc/opts.cc                                   |   20 +-
 gcc/opts.h                                    |   18 +-
 gcc/rust/resolve/rust-ast-resolve-expr.cc     |    2 +-
 .../resolve/rust-late-name-resolver-2.0.cc    |    2 +-
 gcc/selftest-diagnostic.cc                    |   11 +-
 gcc/selftest-diagnostic.h                     |    8 +-
 .../plugin/show_template_tree_color_plugin.cc |    4 +-
 .../gcc.dg/plugin/diagnostic_group_plugin.cc  |   12 +-
 .../diagnostic_plugin_test_show_locus.cc      |    2 +-
 .../gcc.dg/plugin/location_overflow_plugin.cc |    8 +-
 gcc/toplev.cc                                 |    4 +-
 gcc/tree-diagnostic-client-data-hooks.cc      |    2 +-
 gcc/tree-diagnostic.cc                        |    8 +-
 gcc/tree-diagnostic.h                         |    4 +-
 59 files changed, 1523 insertions(+), 1482 deletions(-)
 create mode 100644 gcc/diagnostics/context.h

diff --git a/gcc/ada/gcc-interface/misc.cc b/gcc/ada/gcc-interface/misc.cc
index 128040e4d90d..6de9b42dc9b1 100644
--- a/gcc/ada/gcc-interface/misc.cc
+++ b/gcc/ada/gcc-interface/misc.cc
@@ -292,7 +292,7 @@ gnat_post_options (const char **pfilename ATTRIBUTE_UNUSED)
 /* Here is the function to handle the compiler error processing in GCC.  */
 
 static void
-internal_error_function (diagnostic_context *context, const char *msgid,
+internal_error_function (diagnostics::context *context, const char *msgid,
 			 va_list *ap)
 {
   char *buffer, *p, *loc;
diff --git a/gcc/analyzer/program-point.cc b/gcc/analyzer/program-point.cc
index 30468d768b09..1d5d65c5cc40 100644
--- a/gcc/analyzer/program-point.cc
+++ b/gcc/analyzer/program-point.cc
@@ -234,10 +234,10 @@ function_point::before_supernode (const supernode *supernode,
   return function_point (supernode, from_edge, 0, PK_BEFORE_SUPERNODE);
 }
 
-/* A subclass of diagnostic_context for use by
+/* A subclass of diagnostics::context for use by
    program_point::print_source_line.  */
 
-class debug_diagnostic_context : public diagnostic_context
+class debug_diagnostic_context : public diagnostics::context
 {
 public:
   debug_diagnostic_context ()
@@ -263,7 +263,7 @@ function_point::print_source_line (pretty_printer *pp) const
   // TODO: monospace font
   debug_diagnostic_context tmp_dc;
   gcc_rich_location richloc (stmt->location);
-  diagnostic_source_print_policy source_policy (tmp_dc);
+  diagnostics::source_print_policy source_policy (tmp_dc);
   gcc_assert (pp);
   source_policy.print (*pp, richloc, DK_ERROR, nullptr);
   pp_string (pp, pp_formatted_text (tmp_dc.get_reference_printer ()));
diff --git a/gcc/c-family/c-common.h b/gcc/c-family/c-common.h
index 675708d2680f..40b97e2d90e4 100644
--- a/gcc/c-family/c-common.h
+++ b/gcc/c-family/c-common.h
@@ -979,7 +979,7 @@ extern tree build_va_arg (location_t, tree, tree);
 
 extern const unsigned int c_family_lang_mask;
 extern unsigned int c_common_option_lang_mask (void);
-extern void c_common_diagnostics_set_defaults (diagnostic_context *);
+extern void c_common_diagnostics_set_defaults (diagnostics::context *);
 extern bool c_common_complain_wrong_lang_p (const struct cl_option *);
 extern void c_common_init_options_struct (struct gcc_options *);
 extern void c_common_init_options (unsigned int, struct cl_decoded_option *);
diff --git a/gcc/c-family/c-opts.cc b/gcc/c-family/c-opts.cc
index 91c1a2fa78b8..6c68efd55d70 100644
--- a/gcc/c-family/c-opts.cc
+++ b/gcc/c-family/c-opts.cc
@@ -189,9 +189,9 @@ c_diagnostic_text_finalizer (diagnostics::text_sink &text_output,
 
 /* Common default settings for diagnostics.  */
 void
-c_common_diagnostics_set_defaults (diagnostic_context *context)
+c_common_diagnostics_set_defaults (diagnostics::context *context)
 {
-  diagnostic_text_finalizer (context) = c_diagnostic_text_finalizer;
+  diagnostics::text_finalizer (context) = c_diagnostic_text_finalizer;
   context->set_permissive_option (OPT_fpermissive);
 }
 
diff --git a/gcc/c/c-objc-common.cc b/gcc/c/c-objc-common.cc
index d574bc771289..5c50983544d7 100644
--- a/gcc/c/c-objc-common.cc
+++ b/gcc/c/c-objc-common.cc
@@ -414,7 +414,7 @@ has_c_linkage (const_tree decl ATTRIBUTE_UNUSED)
 }
 
 void
-c_initialize_diagnostics (diagnostic_context *context)
+c_initialize_diagnostics (diagnostics::context *context)
 {
   context->set_pretty_printer (std::make_unique<c_pretty_printer> ());
   c_common_diagnostics_set_defaults (context);
diff --git a/gcc/c/c-tree.h b/gcc/c/c-tree.h
index 364f51df58c9..27a69ae2d8ba 100644
--- a/gcc/c/c-tree.h
+++ b/gcc/c/c-tree.h
@@ -757,7 +757,7 @@ extern tree c_finish_bc_name (location_t, tree, bool);
 extern bool c_objc_common_init (void);
 extern bool c_missing_noreturn_ok_p (tree);
 extern bool c_warn_unused_global_decl (const_tree);
-extern void c_initialize_diagnostics (diagnostic_context *);
+extern void c_initialize_diagnostics (diagnostics::context *);
 extern bool c_var_mod_p (tree x, tree fn);
 extern alias_set_type c_get_alias_set (tree);
 extern int c_type_dwarf_attribute (const_tree, int);
diff --git a/gcc/coretypes.h b/gcc/coretypes.h
index 169a612f643b..b6a922a506c3 100644
--- a/gcc/coretypes.h
+++ b/gcc/coretypes.h
@@ -164,8 +164,10 @@ struct cl_option;
 struct cl_decoded_option;
 struct cl_option_handlers;
 class rich_location;
-class diagnostic_context;
-namespace diagnostics { class text_sink; }
+namespace diagnostics {
+  class context;
+  class text_sink;
+} // namespace diagnostics
 class pretty_printer;
 class diagnostic_event_id_t;
 typedef const char * (*diagnostic_input_charset_callback)(const char *);
diff --git a/gcc/cp/cp-tree.h b/gcc/cp/cp-tree.h
index 39c2fa5cdc49..6242001c63d6 100644
--- a/gcc/cp/cp-tree.h
+++ b/gcc/cp/cp-tree.h
@@ -8699,7 +8699,7 @@ extern alias_set_type cxx_get_alias_set		(tree);
 extern bool cxx_warn_unused_global_decl		(const_tree);
 extern size_t cp_tree_size			(enum tree_code);
 extern bool cp_var_mod_type_p			(tree, tree);
-extern void cxx_initialize_diagnostics		(diagnostic_context *);
+extern void cxx_initialize_diagnostics		(diagnostics::context *);
 extern int cxx_types_compatible_p		(tree, tree);
 extern bool cxx_block_may_fallthru		(const_tree);
 
diff --git a/gcc/cp/error.cc b/gcc/cp/error.cc
index afe9791ed22a..e8e897d1ffa1 100644
--- a/gcc/cp/error.cc
+++ b/gcc/cp/error.cc
@@ -242,7 +242,7 @@ get_current_template ()
 
 erroneous_templates_t *erroneous_templates;
 
-/* Callback function diagnostic_context::m_adjust_diagnostic_info.
+/* Callback function diagnostics::context::m_adjust_diagnostic_info.
 
    Errors issued when parsing a template are automatically treated like
    permerrors associated with the -Wtemplate-body flag and can be
@@ -250,7 +250,7 @@ erroneous_templates_t *erroneous_templates;
    issue an error if we later need to instantiate the template.  */
 
 static void
-cp_adjust_diagnostic_info (diagnostic_context *context,
+cp_adjust_diagnostic_info (diagnostics::context *context,
 			   diagnostic_info *diagnostic)
 {
   if (diagnostic->m_kind == DK_ERROR)
@@ -298,14 +298,14 @@ cp_seen_error ()
    capacities.  */
 
 void
-cxx_initialize_diagnostics (diagnostic_context *context)
+cxx_initialize_diagnostics (diagnostics::context *context)
 {
   cxx_pretty_printer *pp = new cxx_pretty_printer ();
   pp->set_format_postprocessor (std::make_unique<cxx_format_postprocessor> ());
   context->set_pretty_printer (std::unique_ptr<pretty_printer> (pp));
 
   c_common_diagnostics_set_defaults (context);
-  diagnostic_text_starter (context) = cp_diagnostic_text_starter;
+  diagnostics::text_starter (context) = cp_diagnostic_text_starter;
   /* diagnostic_finalizer is already c_diagnostic_text_finalizer.  */
   context->set_format_decoder (cp_printer);
   context->set_adjust_diagnostic_info_callback (cp_adjust_diagnostic_info);
@@ -3789,7 +3789,7 @@ cp_print_error_function (diagnostics::text_sink &text_output,
   /* The above is true for constraint satisfaction also.  */
   if (current_failed_constraint)
     return;
-  diagnostic_context *const context = &text_output.get_context ();
+  diagnostics::context *const context = &text_output.get_context ();
   if (diagnostic_last_function_changed (context, diagnostic))
     {
       pretty_printer *const pp = text_output.get_printer ();
diff --git a/gcc/cp/module.cc b/gcc/cp/module.cc
index c8e79f33af41..077083550a7e 100644
--- a/gcc/cp/module.cc
+++ b/gcc/cp/module.cc
@@ -3883,9 +3883,9 @@ class GTY((chain_next ("%h.parent"), for_user)) module_state {
   void write_macro_maps (elf_out *to, range_t &, unsigned *crc_ptr);
   bool read_macro_maps (line_map_uint_t);
 
-  void write_diagnostic_classification (elf_out *, diagnostic_context *,
+  void write_diagnostic_classification (elf_out *, diagnostics::context *,
 					unsigned *);
-  bool read_diagnostic_classification (diagnostic_context *);
+  bool read_diagnostic_classification (diagnostics::context *);
 
  private:
   void write_define (bytes_out &, const cpp_macro *);
@@ -18344,7 +18344,7 @@ dump_dc_change (unsigned index, unsigned opt, diagnostic_t dk)
 
 void
 module_state::write_diagnostic_classification (elf_out *to,
-					       diagnostic_context *dc,
+					       diagnostics::context *dc,
 					       unsigned *crc_p)
 {
   auto &changes = dc->get_classification_history ();
@@ -18413,7 +18413,7 @@ module_state::write_diagnostic_classification (elf_out *to,
 /* Read any #pragma GCC diagnostic info from the .dgc section.  */
 
 bool
-module_state::read_diagnostic_classification (diagnostic_context *dc)
+module_state::read_diagnostic_classification (diagnostics::context *dc)
 {
   bytes_in sec;
 
diff --git a/gcc/diagnostic-global-context.cc b/gcc/diagnostic-global-context.cc
index ff647c244a50..84b606d9943f 100644
--- a/gcc/diagnostic-global-context.cc
+++ b/gcc/diagnostic-global-context.cc
@@ -29,9 +29,9 @@ along with GCC; see the file COPYING3.  If not see
 #include "diagnostic.h"
 #include "diagnostics/sink.h"
 
-/* A diagnostic_context surrogate for stderr.  */
-static diagnostic_context global_diagnostic_context;
-diagnostic_context *global_dc = &global_diagnostic_context;
+/* A diagnostics::context surrogate for stderr.  */
+static diagnostics::context global_diagnostic_context;
+diagnostics::context *global_dc = &global_diagnostic_context;
 
 /* Standard error reporting routines in increasing order of severity.  */
 
@@ -49,7 +49,7 @@ verbatim (const char *gmsgid, ...)
   va_end (ap);
 }
 
-/* Wrapper around diagnostic_context::diagnostic_impl
+/* Wrapper around diagnostics::context::diagnostic_impl
    implying global_dc and taking a variable argument list.  */
 
 bool
